#include <iostream>
#include <ranges>
#include <vector>
#include <numeric>

#include <ranges>
#include <execution>
#include <algorithm>

int main(){
	size_t N(2), M(5);
	size_t nbElement(N*M);
	
	std::vector<float> vecInput(nbElement), vecOutput(nbElement);
	std::iota(vecInput.begin(), vecInput.end(), 0);
	
	std::span A{vecInput.data(), N * M};
	std::span B{vecOutput.data(), M * N};
	auto v = std::views::cartesian_product(std::views::iota(0lu, N), std::views::iota(0lu, M));
	std::for_each(std::execution::par_unseq,
		std::begin(v), std::end(v),
		[=] (auto idx) {
			auto [i, j] = idx;
			B[i + j * N] = A[i * M + j];
		}
	);
	
	for (const auto & [n, m] : v){
		std::cout << "n = " << n << ", m = " << m << std::endl;
	}
	std::cout << "vecInput = ";
	for(std::vector<float>::iterator it(vecInput.begin()); it != vecInput.end(); ++it){
		std::cout << (*it) << ",  ";
	}
	std::cout << std::endl;
	std::cout << "vecOutput = ";
	for(std::vector<float>::iterator it(vecOutput.begin()); it != vecOutput.end(); ++it){
		std::cout << (*it) << ",  ";
	}
	std::cout << std::endl;
	
	return 0;
}
